/*
     DataInput.cmd
     Randomizer v3 by Don Eitner, 2000

     Sets up user-defined fields and items for Randomizer.cmd.

     This code is neither supported nor under warranty.  Feel free to
     examine and modify this script for your own purposes.  See the
     included readme.txt for additional information.
*/

call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs

parse arg datafile

call AnsiSetup

if datafile = '' then
do
    say 'Enter the name of the data file you wish to use.'
    parse pull datafile
    if datafile = '' then
	   datafile = 'RandomData.dat'
end

fields = linein(datafile,,1)
count = words(fields)

do num = 1 to count
    item.num = linein(datafile,,1)
end

call lineout(datafile)

do forever
    call FieldMenu
    if save = 1 then
	   signal SaveIt
end

exit


SaveIt:

    rc = SysFileDelete(datafile)
    call lineout datafile, fields
    do num = 1 to count
	   call lineout datafile, item.num
    end
    call lineout(datafile)

return


FieldMenu:

    count = words(fields)
    call SysCls
    say center('Main Fields Menu', 80)
    do num = 1 to count
	   data.num = word(fields, num)
        display.num = data.num

	   x1 = lastpos('', display.num)
	   do while x1 <> '0'
		  data2 = substr(display.num, x1+1)
		  data1 = substr(display.num, 1, x1-1)
		  display.num = data1||' '||data2
		  x1 = lastpos('', display.num)
	   end

	   call ArrangeDisplay
	   call SysCurPos row, col
	   say '('||num||')' display.num
    end
    call SysCurPos 17, 0
    say copies('-', 80)
    call SysCurPos 17, 28
    say LWhi||'Please Select From Below'||Non
    call SysCurPos 18, 8
    say '('||LBro||'A'||Non||')dd a Field  ('||LBro||'D'||Non||')elete a Field  ('||LBro||'E'||Non||')dit a Field  ('||LBro||'M'||Non||')ark a field'
    call SysCurPos 19, 21
    say '('||LBro||'H'||Non||')elp  ('||LBro||'S'||Non||')ave & Exit  ('||LBro||'Q'||Non||')uit w/o Save'
    call SysCurPos 20, 0
    say copies('-', 80)
    parse upper pull Selection

    if Selection <= count then
	   signal ItemMenu

    if Selection = 'A' then
    do
	   fields = ''
	   say 'Enter new field name.'
	   count = count + 1
	   parse pull data.count
	   x1 = lastpos(' ', data.count)
	   do while x1 <> '0'
		  data2 = substr(data.count, x1+1)
		  data1 = substr(data.count, 1, x1-1)
		  data.count = data1||''||data2 /* That's ASCII code ALT-29 */
		  x1 = lastpos(' ', data.count)
	   end
	   item.count = 'editme!'
	   do num = 1 to count
		  fields = fields data.num
	   end
	   signal FieldMenu
    end

    if Selection = 'D' then
    do
	   say 'Which field do you wish to delete?'
	   parse pull Selection2
	   if (Selection2 <= count) & (Selection2 > 0) then
	   do
		  say 'Are you sure you want to delete this field and its items?'
		  parse pull junk
		  if translate(junk) = 'Y' then
		  do
			 fields = ''
			 data.Selection2 = ''
			 item.Selection2 = ''
			 do num = 1 to count
				fields = fields data.num
                         end
			 do num = 2 to count
				prevnum = num - 1
				if item.prevnum = '' then
				do
				    item.prevnum = item.num
				    item.num = ''
				end
			 end
			 signal FieldMenu
		  end
		  else
			 signal FieldMenu
	   end
	   else
		  signal FieldMenu
    end

    if Selection = 'E' then
    do
	   say 'Which field do you wish to edit?'
	   parse pull Selection2
	   if (Selection2 <= count) & (Selection2 > 0) then
	   do
		  say 'Current value of field' Selection2 'is' display.Selection2||'.  Enter new value.'
		  parse pull data.Selection2
		  if data.Selection2 = '' then
			 signal FieldMenu
		  else
		  do
			 fields = ''
			 x1 = lastpos(' ', data.Selection2)
			 do while x1 <> '0'
				data2 = substr(data.Selection2, x1+1)
				data1 = substr(data.Selection2, 1, x1-1)
				data.Selection2 = data1||''||data2
				x1 = lastpos(' ', data.Selection2)
			 end
			 do num = 1 to count
				fields = fields data.num
			 end
			 signal FieldMenu
		  end
	   end
	   else
		  signal FieldMenu
    end

    if Selection = 'M' then
    do
	   say 'Which field do you wish to mark/unmark for multiple selections?'
	   parse pull Selection3
	   if (Selection3 <= count) & (Selection3 > 0) then
	   do
		  if pos('',data.Selection3) = 1 then
			 data.Selection3 = substr(data.Selection3,2)
		  else
			 data.Selection3 = ''||data.Selection3
            fields = ''
		  do num = 1 to count
			 fields = fields data.num
		  end
		  signal FieldMenu
	   end
	   else
            signal FieldMenu
    end

    if Selection = 'H' then
    do
	   call GiveHelp
    end

    if Selection = 'S' then
    do
	   save = '1'
	   return save
    end

    if Selection = 'Q' then
	   exit

    Selection = ''

return


ItemMenu:

    Len = words(item.Selection)
    call SysCls
    say center(word(fields, Selection) 'Sub-Menu', 80)
    do num = 1 to Len
	   data.num = word(item.Selection, num)
        display.num = data.num

	   x1 = lastpos('', display.num)
	   do while x1 <> '0'
		  data2 = substr(display.num, x1+1)
		  data1 = substr(display.num, 1, x1-1)
		  display.num = data1||' '||data2
		  x1 = lastpos('', display.num)
	   end

	   call ArrangeDisplay
	   call SysCurPos row, col
	   say '('||num||')' display.num
    end
    call SysCurPos 17, 0
    say copies('-', 80)
    call SysCurPos 17, 28
    say LWhi||'Please Select From Below'||Non
    call SysCurPos 18, 8
    say '('||LBro||'A'||Non||')dd an Item  ('||LBro||'D'||Non||')elete an item  ('||LBro||'E'||Non||')dit an Item  ('||LBro||'P'||Non||')revious Menu'
    call SysCurPos 19, 0
    say copies('-', 80)
    parse upper pull Selected

    if Selected = 'A' then
    do
	   item.Selection = ''
	   say 'Enter new item.'
	   Len = Len + 1
	   parse pull data.Len
	   x1 = lastpos(' ', data.Len)
	   do while x1 <> '0'
		  data2 = substr(data.Len, x1+1)
		  data1 = substr(data.Len, 1, x1-1)
		  data.Len = data1||''||data2 /* That's ASCII code ALT-29 */
		  x1 = lastpos(' ', data.Len)
	   end
	   do num = 1 to Len
		  item.Selection = item.Selection data.num
	   end
	   signal ItemMenu
    end

    if Selected = 'D' then
    do
	   say 'Which item do you wish to delete?'
	   parse pull Selected2
	   if (Selected2 <= Len) & (Selected2 > 0) then
	   do
		  say 'Are you sure you want to delete this item?'
		  parse pull junk
		  if translate(junk) = 'Y' then
		  do
			 item.Selection = ''
			 data.Selected2 = ''
			 do num = 1 to Len
				item.Selection = item.Selection data.num
			 end
			 signal ItemMenu
		  end
		  else
			 signal ItemMenu
	   end
	   else
		  signal ItemMenu
    end

    if Selected = 'E' then
    do
	   say 'Which item do you wish to edit?'
	   parse pull Selected2
	   if (Selected2 <= Len) & (Selected2 > 0) then
	   do
		  say 'Current value of item' Selected2 'is' display.Selected2||'.  Enter new value.'
		  parse pull data.Selected2
		  if data.Selected2 = '' then
			 signal ItemMenu
		  else
		  do
			 item.Selection = ''
			 x1 = lastpos(' ', data.Selected2)
			 do while x1 <> '0'
				data2 = substr(data.Selected2, x1+1)
				data1 = substr(data.Selected2, 1, x1-1)
				data.Selected2 = data1||''||data2
				x1 = lastpos(' ', data.Selected2)
			 end
			 do num = 1 to Len
				item.Selection = item.Selection data.num
			 end
			 signal ItemMenu
		  end
	   end
	   else
		  signal ItemMenu
    end

    if Selected = 'P' then
	   signal FieldMenu

    Selected = ''

return


ArrangeDisplay:

    select
	   when (num > 0 & num < 16) then
	   do
		  row = num + 1
		  col = 2
	   end
	   when (num > 15 & num < 31) then
	   do
		  row = num - 14
		  col = 29
	   end
	   when (num > 30 & num < 46) then
	   do
		  row = num - 29
		  col = 56
	   end
    end

return


GiveHelp:

    call SysCls
    say 'Add a Field allows you to create arrays from which other programs can'
    say 'select one or more items.'
    say
    say 'Delete a Field will delete an entire array of items permanently.'
    say LBro||'USE WITH GREAT CAUTION!'||Non
    say
    say 'Edit a Field allows you to edit the name of a chosen array.'
    say
    say 'Mark a Field allows you to set a chosen array to be selected from multiple'
    say 'times by a calling program which supports this (ie. randomizer2.cmd).'
    say
    say 'Save will save the currently open data file with the currently active'
    say 'array names and items within each array.'
    say
    say 'Quit will exit DataInput without saving changes you have made.'
    key = SysGetKey('NOECHO')

return


AnsiSetup:

    Esc=d2c(27)d2c(91)

/* Attributes */
    Hig=Esc'1m'
    Non=Esc'0m'

/* Foreground Colors */
    Bla=Esc'30m'
    Red=Esc'31m'
    Gre=Esc'32m'
    Bro=Esc'33m'
    Blu=Esc'34m'
    Pur=Esc'35m'
    Tur=Esc'36m'
    Whi=Esc'37m'
    LBla=Hig||Bla
    LRed=Hig||Red
    LGre=Hig||Gre
    LBro=Hig||Bro
    LBlu=Hig||Blu
    LPur=Hig||Pur
    LTur=Hig||Tur
    LWhi=Hig||Whi

/* Background Colors */
    BBla=Esc'40m'
    BRed=Esc'41m'
    BGre=Esc'42m'
    BBro=Esc'43m'
    BBlu=Esc'44m'
    BCya=Esc'45m'
    BTur=Esc'46m'
    BWhi=Esc'47m'

return

